<script lang="ts" setup>
import { onMounted, ref } from 'vue'
import { useAuthStore } from '@/stores/auth';
import { useBranchStore } from '../../stores/branch';
import userService from '@/services/user';
import { useUserStore } from '@/stores/user';
import Chart from "chart.js/auto";
import type { Branch } from '@/types/Branch';
import { id } from 'date-fns/locale';

const userStore = useUserStore()
 const authStore = useAuthStore()
 const branchStore = useBranchStore()

 const total_day = ref(0)
 const total_month = ref(0)
 const total_year = ref(0)
 const itemDates = ref<{ time: Date; name: string; qty: number, total: number, price: number }[]>([])
 const itemMonths = ref<{ date: Date; total: number,price: number }[]>([])
 const itemYears = ref<{ date: Date; total: number,price: number }[]>([])
 const myChart_day = ref<any>(null);
 const myChart_month = ref<any>(null);
 const show = ref<any>(null);
 const title = ref('')
 const branch = ref<{ id: number; name: string }>({ id: 0, name: '' })
 const branchs = ref<{ id: number; name: string }[]>([])


 async function setSales(id:number,by:string){
  
  if(id){
    const sales = await userService.getSales(id,by)
    console.log(sales)
    total_day.value = sales.data.day
    total_month.value = sales.data.month
    total_year.value = sales.data.year
    
  }
  
 }
 
 async function getSaleItemDate(id:number,by:string) {
  if(id){
    const sales = await userService.getSalesItemDate(id,by)
    console.log(sales)
  const itemsArray: { time: Date; name: string; qty: number, total: number, price: number }[] = []
  if (Array.isArray(sales.data)) {
    for (const db of sales.data) {
      itemsArray.push({ 
        time: new Date(db.createdDate), 
        name: db.RECEIPT_DT_NAME, 
        qty: db.RECEIPT_DT_QTY, 
        price: db.RECEIPT_DT_PRICE, 
        total: db.RECEIPT_DT_TOTAL
      })
    }
    itemDates.value = itemsArray
    console.log(itemDates.value)
  } else {
    console.log('no data')
  }
  }
 }

async function getSaleItemMonth(id:number,by:string) {
  if (!id) return;

  const sales = await userService.getSalesItemMonth(id,by);
  console.log(sales);
  const itemsArray: { date: Date; total: number; price: number }[] = [];
  if (Array.isArray(sales.data)) {
    for (const db of sales.data) {
      itemsArray.push({
        date: new Date(db.Receipt_Date),
        total: db.Total_Quantity,
        price: db.Total_Price,
      });
    }
    itemMonths.value = itemsArray.sort((a, b) => a.date.getTime() - b.date.getTime());
    console.log(itemMonths.value);
  } else {
    console.log('no data');
  }


  if (myChart_day.value) {
    myChart_day.value.destroy();
  }

  const data = {
    labels: itemMonths.value.map((item) => item.date.toLocaleDateString('th-TH', {day: '2-digit' })),
    datasets: [
      {
        label: 'จำนวนที่ขายได้',
        data: itemMonths.value.map((item) => item.total),
        stack: 'combined',
        type: 'bar'
        
      },
      {
        label: 'ยอดที่ขายได้',
        data: itemMonths.value.map((item) => item.price),
        stack: 'combined',
      },
    ],
  };

  const config = {
    type: 'line',
    data: data,
    options: {
      plugins: {
        title: {
          display: true,
          text: `การขายประจำเดือน ${new Date().toLocaleDateString(
            'th-TH',
            {
              month: 'long',
              year: 'numeric',
            }
          )}`,
        },
      },
      responsive: true,
      scales: {
      y: {
        stacked: true ,
        beginAtZero: true,
      }
    }
    },
  };

  const ctx = document.getElementById('myChart_day');
  if (ctx) {
    myChart_day.value = new Chart(ctx, config);
  }
}

 async function getSaleItemYear(id:number,by:string) {
  if(id){
    const sales = await userService.getSalesItemYear(id,by)
    console.log(sales)
  const itemsArray: { date: Date, total: number, price: number }[] = []
  if (Array.isArray(sales.data)) {
    for (const db of sales.data) {
      itemsArray.push({ 
        date: new Date(db.Receipt_Month), 
        price: db.Total_Price, 
        total: db.Total_Quantity
      })
    }
    itemYears.value = itemsArray
    console.log(itemYears.value)
  } else {
    console.log('no data')
  }
  if (myChart_month.value) {
    myChart_month.value.destroy();
  }

  const data = {
    labels: itemYears.value.map((item) =>
      item.date.toLocaleDateString('th-TH', {
        month: 'long',
      })
    ),
    datasets: [
      {
        barPercentage: 10,
        barThickness: 50,
        maxBarThickness: 50,
        minBarLength: 50,
        label: 'จำนวนที่ขายได้',
        data: itemYears.value.map((item) => item.total),
        stack: 'Stack 0',
      },
      {
        barPercentage: 10,
        barThickness: 50,
        maxBarThickness: 50,
        minBarLength: 50,
        label: 'ยอดที่ขายได้',
        data: itemYears.value.map((item) => item.price),
        stack: 'Stack 1',
      },
    ],
  };

  const config = {
    type: 'bar',
    data: data,
    options: {
      plugins: {
        title: {
          display: true,
          text: `การขายประจำปี ${new Date().toLocaleDateString(
            'th-TH',
            {
              year: 'numeric',
            }
          )}`,
        },
      },
      responsive: true,
      interaction: {
        intersect: true,
      },
      scales: {
        x: {
          stacked: true,
        },
        y: {
          stacked: true,
        },
      },
    },
  };

  const ctx = document.getElementById('myChart_month');
  if (ctx) {
    myChart_month.value = new Chart(ctx, config);
  }
  }
 }

 function checkRole(){
  branchs.value = branchStore.branches.map((branch) => ({
  id: branch.id ?? -1,
  name: branch.name
}));
  if (authStore.getCurrentUser()!.role.name === "เจ้าของกิจการ") {
    branch.value = {
    id: authStore.getCurrentUser()!.branch.id as number,
    name: authStore.getCurrentUser()!.branch.name
    };
    
  } else if (authStore.getCurrentUser()!.role.name === "ผู้จัดการร้าน") {
    branch.value = {
    id: authStore.getCurrentUser()!.branch.id as number,
    name: authStore.getCurrentUser()!.branch.name
    };
  }
 }

 function showByEmp(){
  show.value = "emp"
  title.value = ""
  setSales(userStore.employee_id,show.value)
    getSaleItemDate(userStore.employee_id,show.value)
    getSaleItemMonth(userStore.employee_id,show.value)
    getSaleItemYear(userStore.employee_id, show.value)
  } 

  function showByBranch(){
  show.value = "branch"
  console.log("Branch: ",branch.value)
  title.value = `สาขา ${branch.value.name}`;
  setSales(branch.value.id,show.value)
  getSaleItemDate(branch.value.id,show.value)
  getSaleItemMonth(branch.value.id,show.value)
  getSaleItemYear(branch.value.id, show.value)
  
  } 
  function showByAll(){
  title.value= "Aqueous"
  show.value = "all"

  setSales(branch.value.id,show.value)
  getSaleItemDate(branch.value.id,show.value)
  getSaleItemMonth(branch.value.id,show.value)
  getSaleItemYear(branch.value.id, show.value)

  } 

 onMounted(async () => {
  await userStore.getUsers()
  checkRole()
  showByEmp()

 })

  </script>

<template>
  <v-sheet>
    <v-card>
      <v-row style="margin: 20px; justify-content: center;">
        <v-btn rounded class="mr-2" @click="showByEmp()">
          You detail
        </v-btn>
        <v-btn rounded class="mr-2" @click="showByAll()"
          v-if="authStore.getCurrentUser()!.role.name === 'เจ้าของกิจการ' && userStore.employee_id == authStore.getCurrentUser()!.id">
          show all
        </v-btn>
        <v-btn rounded @click="showByBranch()"
          v-if="authStore.getCurrentUser()!.role.name === 'ผู้จัดการร้าน' || authStore.getCurrentUser()!.role.name === 'เจ้าของกิจการ' && userStore.employee_id == authStore.getCurrentUser()!.id">
          Branch
        </v-btn>
      </v-row>
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <v-select
            v-if="authStore.getCurrentUser()!.role.name === 'เจ้าของกิจการ' && userStore.employee_id == authStore.getCurrentUser()!.id"
            v-model="branch" label="สาขา" variant="outlined" rounded :items="branchs" item-title="name"
            return-object></v-select>
        </v-col>

      </v-row>

    </v-card>
    <v-card>
      <v-card-title> <span class="text-h5">รายงานการขาย {{ title }}</span></v-card-title>
      <v-card-text>
        <v-row>
          <v-col cols="12" md="4">ยอดขายวันนี้ : {{ total_day }}</v-col>
          <v-col cols="12" md="4">ยอดขายเดือนนี้ : {{ total_month }}</v-col>
          <v-col cols="12" md="4">ยอดขายปีนี้ : {{ total_year }}</v-col>
        </v-row>
      </v-card-text>
    </v-card>

    <v-card>
      <v-card-title class="text-center" style="font-size: 16;">รายการขายประจำวัน </v-card-title>
      <v-card-text>
        <v-table fixed-header style="height: 295px; overflow-y: auto; max-width: 100%">
          <thead>
            <tr>
              <th class="text-left">เวลา</th>
              <th class="text-left">ชื่อสินค้า</th>
              <th class="text-left">ราคา</th>
              <th class="text-left">จำนวน</th>
              <th class="text-left">รวม</th>

            </tr>
          </thead>
          <tbody>
            <tr v-for="(item, index) in itemDates" :key="index">
              <td>{{ new Date(item.time).toLocaleTimeString('th-TH', { hour: 'numeric', minute: 'numeric', second:
                'numeric' }) }}</td>
              <td>{{ item.name }}</td>
              <td>{{ item.price }}</td>
              <td>{{ item.qty }}</td>
              <td>{{ item.total }}</td>
            </tr>
          </tbody>
        </v-table>
      </v-card-text>
    </v-card>
    <v-card>
      <div style="height: 500px; width: 900px">
        <canvas id="myChart_day"></canvas>
      </div>
    </v-card>
    <v-card>
      <v-card-title class="text-center" style="font-size: 16;">ยอดขายประจำเดือน {{ new
        Date().toLocaleDateString('th-TH', { month: 'long', year: 'numeric' }) }} </v-card-title>
      <v-card-text>
        <v-table fixed-header style="height: 295px; overflow-y: auto; max-width: 100%">
          <thead>
            <tr>
              <th class="text-left">วันที่</th>
              <th class="text-left">จำนวนการขาย</th>
              <th class="text-left">ยอดขาย</th>


            </tr>
          </thead>
          <tbody>
            <tr
              v-for="(item, index) in itemMonths.slice().sort((a, b) => new Date(b.date).getTime() - new Date(a.date).getTime())"
              :key="index">
              <td>{{ new Date(item.date).toLocaleDateString('th-TH', { day: 'numeric', month: 'long', year: 'numeric' })
                }}</td>
              <td>{{ item.total }}</td>
              <td>{{ item.price }}</td>
            </tr>
          </tbody>
        </v-table>
      </v-card-text>
    </v-card>
    <v-card>
      <div style="height: 500px; width: 900px">
        <canvas id="myChart_month"></canvas>
      </div>
    </v-card>
    <v-card>
      <v-card-title class="text-center" style="font-size: 16;">ยอดขายประจำปี {{ new Date().toLocaleDateString('th-TH', {
        year: 'numeric' }) }} </v-card-title>
      <v-card-text>
        <v-table fixed-header style="height: 295px; overflow-y: auto; max-width: 100%">
          <thead>
            <tr>
              <th class="text-left">เดือน</th>
              <th class="text-left">จำนวนการขาย</th>
              <th class="text-left">ยอดขาย</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(item, index) in itemYears" :key="index">
              <td>{{ new Date(item.date).toLocaleDateString('th-TH', { month: 'long' }) }}</td>
              <td>{{ item.total }}</td>
              <td>{{ item.price }}</td>
            </tr>
          </tbody>
        </v-table>
      </v-card-text>
    </v-card>
  </v-sheet>
</template>
